{ Copyright (C) 2025  StOver }
Unit
          alignComponentsImpl;

          {$mode objfpc}{$H+}

Interface


Procedure
          Register;

implementation

Uses
          Classes,
          SysUtils,
          Controls,
          Forms,
          Dialogs,
          menuintf,
          IDECommands,
          ToolBarIntf,
          FormEditingIntf,
          propedits,
          lcltype;

          {$R alignComponents_images.res}

Const
          SALIGN_LFT                        = 'align_left';
          SALIGN_RGT                        = 'align_right';
          SALIGN_TOP                        = 'align_top';
          SALIGN_BTM                        = 'align_bottom';

Resourcestring

          SALIGN_LFT_IDEMenuCaption         = 'Nach links ausrichten';
          SALIGN_RGT_IDEMenuCaption         = 'Nach rechts ausrichten';
          SALIGN_TOP_IDEMenuCaption         = 'Nach oben ausrichten';
          SALIGN_BTM_IDEMenuCaption         = 'Nach unten ausrichten';


Type

          { tHelpObj }

          tHelpObj                          = Class( tObject)

             pslCurSelComps                 : tPersistentSelectionList;
             pslCurSelCtrls                 : tPersistentSelectionList;

             Function                       getNonFormSelection( Const aSelection: tPersistentSelectionList): tPersistentSelectionList;
             Function                       getControlSelection(): tPersistentSelectionList;
             Procedure                      PropHookSetSelection( Const aSelection: tPersistentSelectionList);

             Procedure                      xAbleOne( aCmd: tIDEMenuCommand; aEnable: Boolean);
             Procedure                      xAbleCommands( aCompSel: intEger; aCtrlSel: intEger);
             Function                       refreshPSLists( Const aSelection: tPersistentSelectionList): boolEAN;
             Procedure                      refreshCmdsXablation( Const aSelection: tPersistentSelectionList);

             Procedure                      tryRefreshLUR();

             Procedure                      alignTopOrLeft( aIsLeft: Boolean);
             Procedure                      alignLeft( aSender: tObject);
             Procedure                      alignTop( aSender: tObject);

             Procedure                      alignRight( aSender: tObject);
             Procedure                      alignBottom( aSender: tObject);

          Public

             Constructor                    create();
          End;


Var
          imcCmd_LFT: tIDEMenuCommand       = Nil;
          imcCmd_RGT: tIDEMenuCommand       = Nil;
          imcCmd_TOP: tIDEMenuCommand       = Nil;
          imcCmd_BTM: tIDEMenuCommand       = Nil;

          ho_Obj: tHelpObj                  = Nil;


Procedure
          Register;
Var
          Key                               : tIDEShortCut;
          Cat                               : tIdeCommandCategory;
          Cmd                               : tIdeCommand;
Begin
          If not assigned( GlobalDesignHook)
             Then
             Exit;

          Key:= IDEShortCut( vk_unknown, []);
          Cat:= IDECommandList.FindCategoryByName( CommandCategoryToolMenuName);

          // left
          Cmd:= RegisterIDECommand( Cat, SALIGN_LFT, SALIGN_LFT_IDEMenuCaption, Key, @ho_Obj.alignLeft  , Nil);
          RegisterIDEButtonCommand( Cmd);
          imcCmd_LFT:= RegisterIDEMenuCommand( itmSecondaryTools, SALIGN_LFT, SALIGN_LFT_IDEMenuCaption, @ho_Obj.alignLeft  , Nil, Cmd, AnsiLowerCase( SALIGN_LFT));

          // top
          Cmd:= RegisterIDECommand( Cat, SALIGN_TOP, SALIGN_TOP_IDEMenuCaption, Key, @ho_Obj.alignTop   , Nil);
          RegisterIDEButtonCommand( Cmd);
          imcCmd_TOP:= RegisterIDEMenuCommand( itmSecondaryTools, SALIGN_TOP, SALIGN_TOP_IDEMenuCaption, @ho_Obj.alignTop   , Nil, Cmd, AnsiLowerCase( SALIGN_TOP));

          // right
          Cmd:= RegisterIDECommand( Cat, SALIGN_RGT, SALIGN_RGT_IDEMenuCaption, Key, @ho_Obj.alignRight , Nil);
          RegisterIDEButtonCommand( Cmd);
          imcCmd_RGT:= RegisterIDEMenuCommand( itmSecondaryTools, SALIGN_RGT, SALIGN_RGT_IDEMenuCaption, @ho_Obj.alignRight , Nil, Cmd, AnsiLowerCase( SALIGN_RGT));

          // bottom
          Cmd:= RegisterIDECommand( Cat, SALIGN_BTM, SALIGN_BTM_IDEMenuCaption, Key, @ho_Obj.alignBottom, Nil);
          RegisterIDEButtonCommand( Cmd);
          imcCmd_BTM:= RegisterIDEMenuCommand( itmSecondaryTools, SALIGN_BTM, SALIGN_BTM_IDEMenuCaption, @ho_Obj.alignBottom, Nil, Cmd, AnsiLowerCase( SALIGN_BTM));

          GlobalDesignHook.AddHandlerSetSelection( @ho_Obj.PropHookSetSelection);

End;

{ tHelpObj }

Function
          tHelpObj.getNonFormSelection( Const aSelection: tPersistentSelectionList): tPersistentSelectionList;
Var
          vIn1                              : intEger;
          vIn2                              : intEger;
Begin
          Result:= tPersistentSelectionList.Create();

          If assigned( aSelection)
             Then
             Begin
                  vIn2:= aSelection.Count;
                  For vIn1:= 0 To vIn2- 1
                      Do
                      Begin
                           If ( aSelection[ vIn1] is tComponent)
                              And
                              Not ( aSelection[ vIn1] is tCustomForm)
                              Then
                              Result.Add( aSelection[ vIn1]);
                  End;

          End;
End;

Function
          tHelpObj.getControlSelection(): tPersistentSelectionList;
Var
          vIn1                              : intEger;
          vIn2                              : intEger;
Begin
          Result:= tPersistentSelectionList.Create();

          If assigned( pslCurSelComps)
             Then
             Begin
                  vIn2:= pslCurSelComps.Count;
                  For vIn1:= 0 To vIn2- 1
                      Do
                      Begin
                           If ( pslCurSelComps[ vIn1] is tControl)
                              And
                              Not ( pslCurSelComps[ vIn1] is tCustomForm)
                              Then
                              Result.Add( pslCurSelComps[ vIn1]);
                  End;
          End;
End;

Procedure
          tHelpObj.xAbleOne( aCmd: tIDEMenuCommand; aEnable: Boolean);
Begin
          If assigned( aCmd)
             Then
             aCmd.Enabled:= aEnable;
End;

Procedure
          tHelpObj.xAbleCommands( aCompSel: intEger; aCtrlSel: intEger);
Begin
          xAbleOne( imcCmd_LFT, False);
          xAbleOne( imcCmd_RGT, False);
          xAbleOne( imcCmd_TOP, False);
          xAbleOne( imcCmd_BTM, False);
          If ( aCompSel> 1)
             Then
             Begin
                  xAbleOne( imcCmd_LFT, True);
                  xAbleOne( imcCmd_TOP, True);

                  If ( aCompSel= aCtrlSel)
                     Then
                     Begin
                          xAbleOne( imcCmd_RGT, True);
                          xAbleOne( imcCmd_BTM, True);
                  End;
          End;
End;

Function
          tHelpObj.refreshPSLists( Const aSelection: tPersistentSelectionList): boolEAN;
Begin
          Result:= False;

          pslCurSelComps:= getNonFormSelection( aSelection);
          pslCurSelCtrls:= Nil;

          If assigned( pslCurSelComps)
             Then
             Begin
                  pslCurSelCtrls:= getControlSelection();
                  Result:= assigned( pslCurSelCtrls);
          End;
End;

Procedure
          tHelpObj.refreshCmdsXablation( Const aSelection: tPersistentSelectionList);
Var
          vInCmps                           : intEger;
          vInCtrs                           : intEger;
Begin
          xAbleCommands( 0, 0);

          If refreshPSLists( aSelection)
             Then
             Begin
                  vInCmps:= pslCurSelComps.Count;
                  vInCtrs:= pslCurSelCtrls.Count;

                  xAbleCommands( vInCmps, vInCtrs)
          End;
End;


Procedure
          tHelpObj.PropHookSetSelection( Const aSelection: tPersistentSelectionList);
Begin
          refreshCmdsXablation( aSelection);
End;

Procedure
          tHelpObj.tryRefreshLUR();
Begin
          If not assigned( GlobalDesignHook)
             Then
             Exit;

          Try
             If assigned( GlobalDesignHook.LookupRoot)
                And
                ( GlobalDesignHook.LookupRoot Is tControl)
                Then
                tControl( GlobalDesignHook.LookupRoot).rePaint()
          Except End;
End;


Procedure
          tHelpObj.alignTopOrLeft( aIsLeft: Boolean);
Var
          vInLft                            : intEger;
          vInTop                            : intEger;
          vInLftC                           : intEger;
          vInTopC                           : intEger;
          vIn1                              : intEger;
          vIn2                              : intEger;
Begin
          If Not assigned( pslCurSelComps)
             Then
             Exit;

          If ( pslCurSelComps.Count< 2)
             Then
             Exit;

          Try
             GetComponentLeftTopOrDesignInfo( tComponent( pslCurSelComps[ 0]), vInLft, vInTop);

             vIn2:= pslCurSelComps.Count;

             For vIn1:= 1 To vIn2- 1
                 Do
                 Begin
                      GetComponentLeftTopOrDesignInfo( tComponent( pslCurSelComps[ vIn1]), vInLftC, vInTopC);

                      If aIsLeft
                         Then
                         SetComponentLeftTopOrDesignInfo( tComponent( pslCurSelComps[ vIn1]), vInLft, vInTopC)
                      Else
                         SetComponentLeftTopOrDesignInfo( tComponent( pslCurSelComps[ vIn1]), vInLftC, vInTop)
             End;
             tryRefreshLUR();

          Except End;

End;


Procedure
          tHelpObj.alignLeft( aSender: tObject);
Begin
          alignTopOrLeft( True);
End;

Procedure
          tHelpObj.alignTop( aSender: tObject);
Begin
          alignTopOrLeft( False);
End;

Procedure
          tHelpObj.alignRight( aSender: tObject);
Var
          vInDiff                           : intEger;
          vIn1                              : intEger;
          vIn2                              : intEger;

          vtReC0                            : tRect;
          vtReCi                            : tRect;
Begin
          If Not assigned( pslCurSelCtrls)
             Then
             Exit;

          If ( pslCurSelCtrls.Count< 2)
             Then
             Exit;

          Try
             vtReC0:= tControl( pslCurSelCtrls[ 0]).BoundsRect;

             vIn2:= pslCurSelCtrls.Count;

             For vIn1:= 1 To vIn2- 1
                 Do
                 Begin
                      vtReCi:= tControl( pslCurSelCtrls[ vIn1]).BoundsRect;
                      vInDiff:= vtReC0.Right- vtReCi.Right;  // might be negative
                      If ( 0<> vInDiff)
                         Then
                         Begin
                              vtReCi.Right:= vtReC0.Right;
                              vtReCi.Left := vtReCi.Left+ vInDiff;
                              tControl( pslCurSelCtrls[ vIn1]).SetBounds( vtReCi.Left, vtReCi.Top, vtReCi.Width, vtReCi.Height);

                      End;
             End;
             tryRefreshLUR();

          Except End;

End;

Procedure
          tHelpObj.alignBottom( aSender: tObject);
Var
          vInDiff                           : intEger;
          vIn1                              : intEger;
          vIn2                              : intEger;

          vtReC0                            : tRect;
          vtReCi                            : tRect;
Begin
          If Not assigned( pslCurSelCtrls)
             Then
             Exit;

          If ( pslCurSelCtrls.Count< 2)
             Then
             Exit;

          Try
             vtReC0:= tControl( pslCurSelCtrls[ 0]).BoundsRect;

             vIn2:= pslCurSelCtrls.Count;

             For vIn1:= 1 To vIn2- 1
                 Do
                 Begin
                      vtReCi:= tControl( pslCurSelCtrls[ vIn1]).BoundsRect;
                      vInDiff:= vtReC0.Bottom- vtReCi.Bottom;  // might be negative
                      If ( 0<> vInDiff)
                         Then
                         Begin
                              vtReCi.Bottom:= vtReC0.Bottom;
                              vtReCi.Top   := vtReCi.Top+ vInDiff;
                              tControl( pslCurSelCtrls[ vIn1]).SetBounds( vtReCi.Left, vtReCi.Top, vtReCi.Width, vtReCi.Height);

                      End;
             End;
             tryRefreshLUR();

          Except End;

End;


Constructor
          tHelpObj.create();
Begin
          pslCurSelComps:= Nil;
          pslCurSelCtrls:= Nil;
End;



Initialization
Begin
          ho_Obj:= tHelpObj.Create();


End;

Finalization
Begin
          If assigned( GlobalDesignHook)
             Then
             GlobalDesignHook.RemoveHandlerSetSelection( @ho_Obj.PropHookSetSelection);

End;

End.

